
#ifndef _FLEXLCD_H
#define _FLEXLCD_H	1

//---------------- LCD control signals --------------------------
#define LCD_RS_SET()	GPIOB->BSRR = GPIO_BSRR_BS13;
#define LCD_RS_CLR()	GPIOB->BRR  = GPIO_BRR_BR13;

#define LCD_RW_SET()	GPIOB->BSRR = GPIO_BSRR_BS14;
#define LCD_RW_CLR()	GPIOB->BRR	= GPIO_BRR_BR14;

#define LCD_EN_SET()	GPIOB->BSRR = GPIO_BSRR_BS15;
#define LCD_EN_CLR()	GPIOB->BRR  = GPIO_BRR_BR15;

//----------------- LCD DATA bus ----------------------------------
#define LCD_DAT_CLR()	GPIOC->BRR	= GPIO_BRR_BR6 | GPIO_BRR_BR7 | GPIO_BRR_BR8 | GPIO_BRR_BR9;
#define LCD_DAT_RD()	( ( GPIOC->IDR >> 6 ) & 0x0F )
#define LCD_DAT_WR		GPIOC->BSRR
#define LCD_DAT_IN() 	GPIOC->CRH	&= 0xFFFFFF44; \
						GPIOC->CRH	|= 0x00000044; \
						GPIOC->CRL	&= 0x44FFFFFF; \
						GPIOC->CRL	|= 0x44000000;
#define LCD_DAT_OUT()	GPIOC->CRH	&= 0xFFFFFF11; \
						GPIOC->CRH	|= 0x00000011; \
						GPIOC->CRL	&= 0x11FFFFFF; \
						GPIOC->CRL	|= 0x11000000;

//numeric output parameters 
#define SPACE_ALLOW     TRUE  //do not supress spaces
#define SPACE_SUPRESS   FALSE //supress spaces in numeric output

#define DEC_POINT		TRUE
#define NO_POINT		FALSE;

#define lcd_max_x 16//number of chars in one row
#define lcd_max_y 2 //number of rows

#define LCD_RUS 0
#define LCD_ENG 1 /* Pseudo russian encoding */
#define LCD_LANG        LCD_RUS


void lcd_init(void);
void lcd_init_write(char cmd);
void lcd_write_command(char cmd);
void lcd_write_data(char data);
void lcd_clear(void);
void lcd_gotoxy(unsigned char x, unsigned char y);
void lcd_putsf(const char *str);
void lcd_putchar(char chr);
void lcd_print_int
(unsigned int num, unsigned char lead_zero, char use_space, char dec_point);
void lcd_send_data(char dta);
char lcd_read_byte(void);
char lcd_read_BF(void);
void define_char(const unsigned char *pc,unsigned char char_code);

#endif
